function BJT = BJTfunct(Vbb, Vcc, Rb, Rc, B)

Vbe = 0.7;

if (Vbb < 0 || Rb < 0 || Vcc < 0 || Rc < 0)
    error('Negative Values Not Allowed')
end

Ib = (Vbb - Vbe)/Rb;
Ic = B*Ib;
Ie = Ib + Ic;
Vrb = Ib*Rb;
Vrc = Ic*Rc;
Vce = Vcc - Vrc;
Mode = 0;

if (Ib < 0 && Vce > 0)
    Ib = 0;
    Ic = 0;
    Ie = 0;
    Vrb = 0;
    Vrc = 0;
    Vce = Vcc;
    Mode = 3; %Cutoff
    
elseif (Vce >= 0.5)
    Mode = 1; %Forward Active
    
elseif (Vce < 0.5 && Vce > 0)
    Mode = 2; %Saturation
    Ic = 10*Ib;
    Ie = Ib + Ic;
    Vrb = Ib*Rb;
    Vrc = Ic*Rc;
    Vce = Vcc - Vrc;
    
else
    Mode = 4;
end

Ib = Ib*1000;

BJT = [Vbb Vcc Rb Rc Mode Ib Ic Ie Vrb Vrc Vce];

end