function MOSFET = MOSFETfunct(Vdd, Vgg, Rd)

Cox = 200*(10^-9);
mu = 200;
W = 25*(10^-6);
L = 1*(10^-6);
Vt = 0.7;

if (Vdd < 0 | Rd < 0 | Vgg < 0)
    error('Negative Values Not Allowed')
end

Vgs = Vgg;
Id = mu*Cox*(W/L)*((Vgs-Vt)^2)/2;
Vrd = Id*Rd;
Vds = Vdd - Vrd;

if (Vds < 0)
    Mode = 4;
    
elseif (Vgs < Vt)
    Mode = 3; %cutoff
    Id = 0;
    
elseif (Vds < Vgs - Vt)
    Mode = 2; %triode
    Id = mu*Cox*(W/L)*(((Vgs-Vt)*Vds)-((Vds^2)/2))

else
    Mode = 1; %saturation
    Id = mu*Cox*(W/L)*((Vgs-Vt)^2)/2
    
end

Vrd = Id*Rd;
Vds = Vdd - Vrd;
Id = Id*1000;
Is = Id;

MOSFET = [Vdd Vgg Rd Mode Id Is Vrd Vds Vgs]
end